/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 14.3
*/

#include<stdio.h>
#include<math.h>

#define Pi 3.14159265358979323

class Circle
{
private:
  double Radius, Area, Perimeter;
  void calArea()
  {
    Area = Pi * Radius * Radius;
  }
  void calPerimeter()
  {
    Perimeter = 2.0 * Pi * Radius;
  }

public:
  void set_Radius(double r)
  {
    Radius = fabs(r);
    calArea();
    calPerimeter();
  }

  void set_Area(double A)
  {
    Radius = sqrt(fabs(A) / Pi);
    Area = fabs(A);
    calPerimeter();
  }

  void set_Perimeter(double P)
  {
    Radius = 0.5 * fabs(P) / Pi;
    Perimeter = fabs(P);
    calArea();
  }

  double get_Radius()     { return Radius;    }
  double get_Area()       { return Area;      }
  double get_Perimeter()  { return Perimeter; }

  void Report()
  {
    printf("Radius = %8.4lf, Area = %8.4lf, Perimeter = %8.4lf\n", Radius, Area, Perimeter);
  }
};

int main()
{
  Circle C;

  C.set_Radius(5.0);       C.Report();
  C.set_Area(-5.0);        C.Report();
  C.set_Perimeter(85.0);   C.Report();

  getchar();
  return 0;
}